package de.kebidge.middleware;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Optional;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

// WRONG IMPORT!!!
//import io.swagger.v3.oas.annotations.parameters.RequestBody;


@RestController
public class ShoppingAPI {

    @Autowired
    ShoppingItemRepository shoppingItemRepository;
    
    Logger logger = LoggerFactory.getLogger(ShoppingAPI.class);

    @GetMapping("/shoppingItem")
    public ArrayList<Optional<ShoppingItem>> getShoppingItems() {
        
    
        Iterable<ShoppingItem> iterableItems = shoppingItemRepository.findAll();

        ArrayList<String> itemList = new ArrayList<String>();
        ArrayList<Optional<ShoppingItem>> optionalItemList = new ArrayList<Optional<ShoppingItem>>();
        
        Iterator<ShoppingItem> itemTerator = iterableItems.iterator();

        logger.info("----- GET Item -----");

        while(itemTerator.hasNext()){
            ShoppingItem tempItem = itemTerator.next();
            Optional<ShoppingItem> optionalTempItem = shoppingItemRepository.findById(tempItem.id);
            itemList.add(tempItem.item);
            optionalItemList.add(optionalTempItem);
            logger.info("id = {}", optionalTempItem.get().id);
            logger.info("item = {}", optionalTempItem.get().item);
            logger.info("amount = {}", optionalTempItem.get().amount);
        }

        return optionalItemList;

    }

    @GetMapping("/shoppingItem/{id}")
    public Optional<ShoppingItem> getShoppingItem(@PathVariable long id) {

        logger.info("----- GET Item by ID -----");
        Optional<ShoppingItem> item = shoppingItemRepository.findById(id);
        logger.info("id = {}", item.get().id);
        logger.info("item = {}", item.get().item);
        logger.info("amount = {}", item.get().amount);

        return item;
    }

    @PostMapping(path = "/shoppingItem/{item}/{amount}", produces = "application/json")
    public ShoppingItem addShoppingItemJSON(@PathVariable String item, @PathVariable int amount){

        ShoppingItem newItem = new ShoppingItem(item);


        Iterable<ShoppingItem> iterableItems = shoppingItemRepository.findAll();
        Iterator<ShoppingItem> itemTerator = iterableItems.iterator();

        while(itemTerator.hasNext()){

            ShoppingItem tempItem = itemTerator.next();

            if (tempItem.item.equals(item)) {

                logger.info("----- ADD Item with Amount-----");  

                int newAmount = tempItem.amount + amount;

                newItem.setId(tempItem.id);
                newItem.setAmount(newAmount);
                shoppingItemRepository.save(newItem);  

                logger.info("new id = {}", tempItem.id);
                logger.info("new item = {}", tempItem.item);
                logger.info("amount = {}", newAmount);

                //return "Increased Amount (from " + (tempItem.amount - amount) + " to " + newItem.amount + ") of " + newItem.item + " successfully in shoppingItemRepository";
                return newItem;
            }
        }

        
        newItem.setAmount(amount);

        shoppingItemRepository.save(newItem);

        logger.info("----- ADD Item with Amount-----");    
        logger.info("new id = {}", newItem.id);
        logger.info("new item = {}", newItem.item);
        logger.info("amount = {}", amount);

        //return "Added " + newItem.item + " with an Amount of " + amount + " successfully to shoppingItemRepository";
        return newItem;

    }

    @PostMapping("/shoppingItem/{item}")
    public String addShoppingItem(@PathVariable String item){

        ShoppingItem newItem = new ShoppingItem(item);

        Iterable<ShoppingItem> iterableItems = shoppingItemRepository.findAll();
        Iterator<ShoppingItem> itemTerator = iterableItems.iterator();

        while(itemTerator.hasNext()){

            ShoppingItem tempItem = itemTerator.next();

            if (tempItem.item.equals(item)) {

                logger.info("----- ADD Item -----");  

                newItem.setId(tempItem.id);
                newItem.setAmount(tempItem.amount + 1);
                shoppingItemRepository.save(newItem);  

                logger.info("new id = {}", tempItem.id);
                logger.info("new item = {}", tempItem.item);
                logger.info("new amount = {}", tempItem.amount);

                return "Increased Amount (from " + (tempItem.amount - 1) + " to " + newItem.amount + ") of " + newItem.item + " successfully in shoppingItemRepository";
            }

        }


        shoppingItemRepository.save(newItem);

        logger.info("----- ADD Item -----");    
        logger.info("new id = {}", newItem.id);
        logger.info("new item = {}", newItem.item);
        logger.info("new amount = {}", newItem.amount);

        return "Added " + newItem.item + " successfully to shoppingItemRepository";

    }

    @PostMapping(consumes = "application/json", produces = "application/json", path = "/shoppingItem/add")
    public ShoppingItem addShoppingItemRequestBody(@RequestBody ShoppingItem newItem) {

        Iterable<ShoppingItem> iterableItems = shoppingItemRepository.findAll();
        Iterator<ShoppingItem> itemTerator = iterableItems.iterator();

        while(itemTerator.hasNext()){

            ShoppingItem tempItem = itemTerator.next();

            if (tempItem.item.equals(newItem.item)) {

                logger.info("----- ADD Item via UI with Amount-----");  

                int newAmount = tempItem.amount + newItem.getAmount();

                newItem.setId(tempItem.id);
                newItem.setAmount(newAmount);

                shoppingItemRepository.save(newItem);  

                logger.info("new id = {}", newItem.id);
                logger.info("new item = {}", newItem.item);
                logger.info("amount = {}", newAmount);

                return newItem;
            }
        }

        shoppingItemRepository.save(newItem);

        logger.info("----- ADD Item via UI -----");  
        logger.info("new id = {}", newItem.id);
        logger.info("new item = {}", newItem.item);
        logger.info("new amount = {}", newItem.amount);

        return newItem;
    }

    @PutMapping("/shoppingItem/{old_item}/{new_item}")
    public String updaShoppingItem(@PathVariable String old_item, @PathVariable String new_item) {

		Iterable<ShoppingItem> iterableItems = shoppingItemRepository.findAll();
        Iterator<ShoppingItem> itemTerator = iterableItems.iterator();

        while(itemTerator.hasNext()){

            ShoppingItem tempItem = itemTerator.next();
            ShoppingItem myNewItem = new ShoppingItem(new_item);

            if (tempItem.item.equals(old_item)) {
                
                logger.info("----- UPDATE Item -----");    
                logger.info("old id = {}", tempItem.id);
                logger.info("old item = {}", tempItem.item);
                logger.info("old amount = {}", tempItem.amount);

                myNewItem.setId(tempItem.id);
                myNewItem.setItem(new_item);
                myNewItem.setAmount(tempItem.amount);

                logger.info("new id ={}", myNewItem.id);
                logger.info("new item ={}", myNewItem.item);
                logger.info("new amount ={}", myNewItem.amount);

                shoppingItemRepository.save(myNewItem);

                return "Updated " + old_item + " to " + myNewItem.item;
            } 
        }

        logger.info("----- ERROR: UPDATE Item -----");   
        return "Update failed: Could not find old_item=" + old_item;
    }

    @DeleteMapping("/shoppingItem/del-id/{id}")
    public String deleteShoppingItemById(@PathVariable long id) {

        if(shoppingItemRepository.existsById(id)) {
            
            logger.info("----- DELETE Item by ID -----");

            Optional<ShoppingItem> item = shoppingItemRepository.findById(id);
            long del_id = item.get().id;
            String del_item = item.get().item;
            logger.info("id = {}", del_id);
            logger.info("item = {}", del_item);

            shoppingItemRepository.deleteById(id);    
            return "Deleted " + del_item + " (" + del_id + ") sucessfully";
        }

        logger.info("----- ERROR: DELETE Item by ID -----");        
        return "Delete failed: cant find item by id =" + id;
    }

    @DeleteMapping("/shoppingItem/del-item/{item}")
    public String deleteShoppingItem(@PathVariable String item) {

		List<ShoppingItem> items = (List<ShoppingItem>) shoppingItemRepository.findAll();
        Iterable<ShoppingItem> iterableItems = shoppingItemRepository.findAll();        
        Iterator<ShoppingItem> itemTerator = iterableItems.iterator();

        while(itemTerator.hasNext()){

            ShoppingItem tempItem = itemTerator.next();
            Optional<ShoppingItem> optionalItem = shoppingItemRepository.findById(tempItem.id);

            if (tempItem.item.equals(item)) {

                // CHECK AMOUNT FIRST

                int itemAmount = optionalItem.get().amount;
                long itemId = optionalItem.get().id;

                if(itemAmount > 1) {

                    /****************************************************
                     *  ID bring nix da automatisch generiert !!!!!!!
                     *  is aber nich schlimm
                     *  amount ist ja richtig                      
                     */

                    ShoppingItem newItem = new ShoppingItem(item);
                    
                    newItem.setAmount(itemAmount - 1);
                    newItem.setId(itemId);
                    //shoppingItemRepository.delete(tempItem);

                    logger.info("----- DELETE Item (Amount) -----");
                    logger.info("id = {}", newItem.id);
                    logger.info("item = {}", newItem.item);
                    logger.info("amount = {}", newItem.amount);
                    shoppingItemRepository.save(newItem);
                    
                    return "Decreased Amount (from " + (newItem.amount + 1) + " to " + newItem.amount + ") of " + newItem.item + " successfully in shoppingItemRepository";
        
                }



                logger.info("----- DELETE Item-----");
                logger.info("delete id = {}", tempItem.id);
                logger.info("delete item = {}", tempItem.item);
                logger.info("delete amount = {}", tempItem.amount);

                shoppingItemRepository.delete(tempItem);            
                return "Deleted " + tempItem.item + " sucessfully";
            } 
        }

        logger.info("----- ERROR: DELETE Item -----");        
        return "Delete failed: cant find item=" + item + " or " + "shoppingItemRepository is empty (size=" + items.size() + ")";
        
    }

    @DeleteMapping("/shoppingItem/del-all")
    public String deleteAllShoppingItems() {

        Iterable<ShoppingItem> iterableItems = shoppingItemRepository.findAll();        
        Iterator<ShoppingItem> itemTerator = iterableItems.iterator();
        
        logger.info("----- DELETE shoppingItemRepository -----"); 

        while(itemTerator.hasNext()){

            ShoppingItem tempItem = itemTerator.next();
            logger.info("delete id = {}", tempItem.id);
            logger.info("delete item = {}", tempItem.item);
            shoppingItemRepository.delete(tempItem); 
        }

        return "Deleted shoppingItemRepository successfully";
    }
}
